//+------------------------------------------------------------------+
//|                                                Phantom_AddSix_01x |
//+------------------------------------------------------------------+
/*
Attach to any chart, any timeframe. Do not attach to more than one
chart.

These are the pairs we trade:

For InterbankFX
---------------
Group 1, The Phantom Buys
1.  GBPUSD
2.  EURGBP
3.  GBPJPY
4.  USDCHF
5.  NZDUSD
6.  AUDJPY
7.  EURJPY

Group 2, The Phantom Sells
8.  EURUSD
9.  USDJPY
10. AUDUSD
11. NZDJPY
12. GBPCHF
13. CHFJPY
14. EURCHF

Initially, buy the phantom buy group of pairs and sell the phantom-sell
group of pairs.

Every hour, add a real trade of every winning phantom pair if the pair is
EURCHF, EURJPY, CHFJPY, GBPCHF, GBPUSD, USDCHF, but only76 if all previous
trades for that pair are winners.

Close all when current equity exceeds ProfitPct above last flat equity.

*/

//+------------------------------------------------------------------+
//|              External Variables                                  |
//+------------------------------------------------------------------+


//:::::::::::::::::::::::::::::::::::::::::::::
/*#include <mt4accountinfo.mqh>
#include <mt4string.mqh>
#include <mt4datetime.mqh>
#include <mt4objects_1.mqh>
#include <mt4timeseries_2.mqh>*/
//Etc.
//:::::::::::::::::::::::::::::::::::::::::::::::
#include <VirtualOrderManager.mqh>

input bool   Bailout = false;

input int    Slippage         =       3;
input int    MiniSize         =   10000;
input int    StdSize          =  100000;

input int GBPUSDidx = 0;
input int EURGBPidx = 1;
input int GBPJPYidx = 2;
input int USDCHFidx = 3;
input int NZDUSDidx = 4;
input int AUDJPYidx = 5;
input int EURJPYidx = 6;

input int EURUSDidx = 7;
input int USDJPYidx = 8;
input int AUDUSDidx = 9;
input int NZDJPYidx = 10;
input int GBPCHFidx = 11;
input int CHFJPYidx = 12;
input int EURCHFidx = 13;

input int Sunday    = 0;
input int Monday    = 1;
input int Tuesday   = 2;
input int Wednesday = 3;
input int Thursday  = 4;
input int Friday    = 5;
input int Saturday  = 6;

input bool   UserTradingAllowed   = true;
input bool   StopAfterNoTrades    = false;
input bool   UseSmallestLot       = false;

input double MaxMarginToUse      =     0.2; // Maximum percent of margin to commit to each trade.
input double Lots                =     0.1;
input double ProfitPct           =     1.0;
input double MaxMiniProfit       =  1000.0;
input double MaxStdProfit        = 10000.0;

input int    MagicNumber         =  777111;
input int startHour = 17;
input int startMinute = 1;


//+------------------------------------------------------------------+
//|              Internal Variables                                  |
//+------------------------------------------------------------------+

//int i, j;
int OrderSendResult;
int Leverage;
int NumBuys, NumSells;
int TotalTrades;
int AccountTypeVal;

int GBPUSDbuys, GBPUSDsells;
int EURGBPbuys, EURGBPsells;
int GBPJPYbuys, GBPJPYsells;
int USDCHFbuys, USDCHFsells;
int NZDUSDbuys, NZDUSDsells;
int AUDJPYbuys, AUDJPYsells;
int EURJPYbuys, EURJPYsells;

int EURUSDbuys, EURUSDsells;
int USDJPYbuys, USDJPYsells;
int AUDUSDbuys, AUDUSDsells;
int NZDJPYbuys, NZDJPYsells;
int GBPCHFbuys, GBPCHFsells;
int CHFJPYbuys, CHFJPYsells;
int EURCHFbuys, EURCHFsells;

bool AccountIsMini;
bool CloseNextLoser;
bool CloseAll;
bool BidsHaveChanged = false;
bool Group1LongGroup2Short, Group1ShortGroup2Long;

string AccountTypeString;
string LastFlatBal;           double valLastFlatBal;
string LastFlatEq;            double valLastFlatEq;
string LowestMarginLevel;     double valLowestMarginLevel;
string LargestFloatingLoss;   double valLargestFloatingLoss;
string MaxFloatingDrawdown;   double valMaxFloatingDrawdown;

string GBPUSDadded; bool valGBPUSDadded;
string EURGBPadded; bool valEURGBPadded;
string GBPJPYadded; bool valGBPJPYadded;
string USDCHFadded; bool valUSDCHFadded;
string NZDUSDadded; bool valNZDUSDadded;
string AUDJPYadded; bool valAUDJPYadded;
string EURJPYadded; bool valEURJPYadded;

string EURUSDadded; bool valEURUSDadded;
string USDJPYadded; bool valUSDJPYadded;
string AUDUSDadded; bool valAUDUSDadded;
string NZDJPYadded; bool valNZDJPYadded;
string GBPCHFadded; bool valGBPCHFadded;
string CHFJPYadded; bool valCHFJPYadded;
string EURCHFadded; bool valEURCHFadded;

string GBPUSDsym;
string EURGBPsym;
string GBPJPYsym;
string USDCHFsym;
string NZDUSDsym;
string AUDJPYsym;
string EURJPYsym;

string EURUSDsym;
string USDJPYsym;
string AUDUSDsym;
string NZDJPYsym;
string GBPCHFsym;
string CHFJPYsym;
string EURCHFsym;



string SymbolArray[14];

double MaxLots;
double MinLots;
double UseLots, TotalLots, BuyLots, SellLots;
double phantomEAPL, phantomBuyPL, phantomSellPL, PairOverallPL, EAPL, BuyPL, SellPL, EquityExit;
double PercentMarginLevel;
double DollarProfitTarget;
double MaxMarginVar;
double Investment;

// PL for real trades

double GBPUSDPL;
double EURGBPPL;
double GBPJPYPL;
double USDCHFPL;
double NZDUSDPL;
double AUDJPYPL;
double EURJPYPL;

double EURUSDPL;
double USDJPYPL;
double AUDUSDPL;
double NZDJPYPL;
double GBPCHFPL;
double CHFJPYPL;
double EURCHFPL;

// PL for phantom trades

double GBPUSD_PL;
double EURGBP_PL;
double GBPJPY_PL;
double USDCHF_PL;
double NZDUSD_PL;
double AUDJPY_PL;
double EURJPY_PL;

double EURUSD_PL;
double USDJPY_PL;
double AUDUSD_PL;
double NZDJPY_PL;
double GBPCHF_PL;
double CHFJPY_PL;
double EURCHF_PL;

double prevGBPUSDbid = 0.0;
double prevEURGBPbid = 0.0;
double prevGBPJPYbid = 0.0;
double prevUSDCHFbid = 0.0;
double prevNZDUSDbid = 0.0;
double prevAUDJPYbid = 0.0;
double prevEURJPYbid = 0.0;

double prevEURUSDbid = 0.0;
double prevUSDJPYbid = 0.0;
double prevAUDUSDbid = 0.0;
double prevNZDJPYbid = 0.0;
double prevGBPCHFbid = 0.0;
double prevCHFJPYbid = 0.0;
double prevEURCHFbid = 0.0;

double BiggestWinnerPL;
double BiggestWinnerLots;
int    BiggestWinnerTicket;
string BiggestWinnerType;
string BiggestWinnerSymbol;

double BiggestLoserPL;
double BiggestLoserLots;
int    BiggestLoserTicket;
string BiggestLoserType;
string BiggestLoserSymbol;

double BiggestPhantomWinnerPL;
string BiggestPhantomWinnerType;
string BiggestPhantomWinnerSymbol;

string strGBPUSDask; double GBPUSDask = 0.0, GBPUSDpoint, GBPUSDtickval;
string strEURGBPask; double EURGBPask = 0.0, EURGBPpoint, EURGBPtickval;
string strGBPJPYask; double GBPJPYask = 0.0, GBPJPYpoint, GBPJPYtickval;
string strUSDCHFask; double USDCHFask = 0.0, USDCHFpoint, USDCHFtickval;
string strNZDUSDask; double NZDUSDask = 0.0, NZDUSDpoint, NZDUSDtickval;
string strAUDJPYask; double AUDJPYask = 0.0, AUDJPYpoint, AUDJPYtickval;
string strEURJPYask; double EURJPYask = 0.0, EURJPYpoint, EURJPYtickval;

string strEURUSDbid; double EURUSDbid = 0.0, EURUSDpoint, EURUSDtickval;
string strUSDJPYbid; double USDJPYbid = 0.0, USDJPYpoint, USDJPYtickval;
string strAUDUSDbid; double AUDUSDbid = 0.0, AUDUSDpoint, AUDUSDtickval;
string strNZDJPYbid; double NZDJPYbid = 0.0, NZDJPYpoint, NZDJPYtickval;
string strGBPCHFbid; double GBPCHFbid = 0.0, GBPCHFpoint, GBPCHFtickval;
string strCHFJPYbid; double CHFJPYbid = 0.0, CHFJPYpoint, CHFJPYtickval;
string strEURCHFbid; double EURCHFbid = 0.0, EURCHFpoint, EURCHFtickval;

double PL_Array[14];
double TickvalArray[14];

bool started=false;
bool debugPrinted=false;

//+------------------------------------------------------------------+
//|   Expert Advisor Initialization, executes only when the EA is    |
//|   first attached to a chart or on platform  restart.             |
//+------------------------------------------------------------------+

int OnInit()
{
    VOM.Initialise();
  //:::::::::::::::::::::::::::::::::::::::::::::
  double Ask=SymbolInfoDouble(Symbol(),SYMBOL_ASK);
  double Bid=SymbolInfoDouble(Symbol(),SYMBOL_BID);
  int Bars=Bars(Symbol(),PERIOD_CURRENT);
  double Point=Point();
  //Etc.
  //:::::::::::::::::::::::::::::::::::::::::::::::

  SetGlobalVariableNames();
  InitGlobalVars();
  ResetPhantoms();

  return (0);
}

//+------------------------------------------------------------------+
//|    Expert Advisor start function, executes on each tick of the   |
//|    currecy pair it's attached to.                                |
//+------------------------------------------------------------------+

void OnTick()
{
  //:::::::::::::::::::::::::::::::::::::::::::::
  double Ask=SymbolInfoDouble(Symbol(),SYMBOL_ASK);
  double Bid=SymbolInfoDouble(Symbol(),SYMBOL_BID);
  int Bars=Bars(Symbol(),PERIOD_CURRENT);
  double Point=Point();
  //Etc.
  //:::::::::::::::::::::::::::::::::::::::::::::::
  
   VOM.OnTick();

  int hour = TimeHourMQL4(TimeCurrent());
  int minute = TimeMinuteMQL4(TimeCurrent());
  
  /*if(!started)
  {
   Print("not started yet");
  }*/
/*  if(!started && (startHour < 0 || startHour < hour || (startHour==hour && startMinute==minute )))   
  {
   started = true;
   Print("started on ",hour,":",minute);
  }
  
  if(!started)
   return;*/
  //Print(hour,",",minute);
  if(minute==0 && !debugPrinted)
  {
   PrintComments();
   debugPrinted = true;
  }
  if(debugPrinted && minute>0)
   debugPrinted = false;
   
  

  RefreshGlobalVars();
  GetAccountInfo();  
  SetSymbols();
  SetAccountType();
  SetLotSize();  
  Count_PL_Trades_Lots();
  SetExitTargets();

  BidsHaveChanged = 

    prevGBPUSDbid != 0.0 &&
    prevEURGBPbid != 0.0 &&
    prevGBPJPYbid != 0.0 &&
    prevUSDCHFbid != 0.0 &&
    prevNZDUSDbid != 0.0 &&
    prevAUDJPYbid != 0.0 &&
    prevEURJPYbid != 0.0 &&

    prevEURUSDbid != 0.0 &&
    prevUSDJPYbid != 0.0 &&
    prevAUDUSDbid != 0.0 &&
    prevNZDJPYbid != 0.0 &&
    prevGBPCHFbid != 0.0 &&
    prevCHFJPYbid != 0.0 &&
    prevEURCHFbid != 0.0 &&

    
    (prevGBPUSDbid != SymbolInfoDouble(GBPUSDsym, SYMBOL_BID) ||
     prevEURGBPbid != SymbolInfoDouble(EURGBPsym, SYMBOL_BID) ||
     prevGBPJPYbid != SymbolInfoDouble(GBPJPYsym, SYMBOL_BID) ||
     prevUSDCHFbid != SymbolInfoDouble(USDCHFsym, SYMBOL_BID) ||
     prevNZDUSDbid != SymbolInfoDouble(NZDUSDsym, SYMBOL_BID) ||
     prevAUDJPYbid != SymbolInfoDouble(AUDJPYsym, SYMBOL_BID) ||
     prevEURJPYbid != SymbolInfoDouble(EURJPYsym, SYMBOL_BID) ||
     prevEURUSDbid != SymbolInfoDouble(EURUSDsym, SYMBOL_BID) ||
     prevUSDJPYbid != SymbolInfoDouble(USDJPYsym, SYMBOL_BID) ||
     prevAUDUSDbid != SymbolInfoDouble(AUDUSDsym, SYMBOL_BID) ||
      prevNZDJPYbid != SymbolInfoDouble(NZDJPYsym, SYMBOL_BID) ||
     prevGBPCHFbid != SymbolInfoDouble(GBPCHFsym, SYMBOL_BID) ||
     prevCHFJPYbid != SymbolInfoDouble(CHFJPYsym, SYMBOL_BID) ||
     prevEURCHFbid != SymbolInfoDouble(EURCHFsym, SYMBOL_BID));

/*Print("GBPUSD changed:",prevGBPUSDbid != SymbolInfoDouble(GBPUSDsym, SYMBOL_BID));
Print("EURGBP changed:",prevEURGBPbid != SymbolInfoDouble(EURGBPsym, SYMBOL_BID));
Print("GBPJPY changed:",prevGBPJPYbid != SymbolInfoDouble(GBPJPYsym, SYMBOL_BID));
Print("USDCHF changed:",prevUSDCHFbid != SymbolInfoDouble(USDCHFsym, SYMBOL_BID));
Print("NZDUSD changed:",prevNZDUSDbid != SymbolInfoDouble(NZDUSDsym, SYMBOL_BID));
Print("AUDJPY changed:",prevAUDJPYbid != SymbolInfoDouble(AUDJPYsym, SYMBOL_BID));
Print("EURJPY changed:",prevEURJPYbid != SymbolInfoDouble(EURJPYsym, SYMBOL_BID));
Print("EURUSD changed:",prevEURUSDbid != SymbolInfoDouble(EURUSDsym, SYMBOL_BID));
Print("USDJPY changed:",prevUSDJPYbid != SymbolInfoDouble(USDJPYsym, SYMBOL_BID));
Print("AUDUSD changed:",prevAUDUSDbid != SymbolInfoDouble(AUDUSDsym, SYMBOL_BID));

Print("NZDJPY changed:",prevNZDJPYbid != SymbolInfoDouble(NZDJPYsym, SYMBOL_BID));
Print("GBPCHF changed:",prevGBPCHFbid != SymbolInfoDouble(GBPCHFsym, SYMBOL_BID));
Print("CHFJPY changed:",prevCHFJPYbid != SymbolInfoDouble(CHFJPYsym, SYMBOL_BID));
Print("EURCHF changed:",prevEURCHFbid != SymbolInfoDouble(EURCHFsym, SYMBOL_BID));*/


  CloseAllTradesIfNeeded();
  OpenPhantomTrades();
  CalcPhantomPL();
  AddIfNeeded();

  if (TotalTrades == 0)
  {
    if (AccountInfoDouble(ACCOUNT_BALANCE) > valLastFlatBal)
    {
      valLastFlatBal = AccountInfoDouble(ACCOUNT_BALANCE);
      GlobalVariableSet(LastFlatBal, valLastFlatBal);
    }

    if (AccountInfoDouble(ACCOUNT_EQUITY) > valLastFlatEq)
    {
      valLastFlatEq = AccountInfoDouble(ACCOUNT_EQUITY);
      GlobalVariableSet(LastFlatEq,  valLastFlatEq);
    }

    //if (!IsExpertEnabled() || StopAfterNoTrades) return(0);

    CloseAll = false;
  }

  if (!CloseAll && valLastFlatEq != 0.0 && AccountInfoDouble(ACCOUNT_EQUITY)-valLastFlatEq > DollarProfitTarget)
  {
    CloseAll = true;
    ResetPhantoms();

    return;
  }

  ExamineMarginAndFloat();

  prevGBPUSDbid = SymbolInfoDouble(GBPUSDsym, SYMBOL_BID);
  prevEURGBPbid = SymbolInfoDouble(EURGBPsym, SYMBOL_BID);
  prevGBPJPYbid = SymbolInfoDouble(GBPJPYsym, SYMBOL_BID);
  prevUSDCHFbid = SymbolInfoDouble(USDCHFsym, SYMBOL_BID);
  prevNZDUSDbid = SymbolInfoDouble(NZDUSDsym, SYMBOL_BID);
  prevAUDJPYbid = SymbolInfoDouble(AUDJPYsym, SYMBOL_BID);
  prevEURJPYbid = SymbolInfoDouble(EURJPYsym, SYMBOL_BID);

  prevEURUSDbid = SymbolInfoDouble(EURUSDsym, SYMBOL_BID);
  prevUSDJPYbid = SymbolInfoDouble(USDJPYsym, SYMBOL_BID);
  prevAUDUSDbid = SymbolInfoDouble(AUDUSDsym, SYMBOL_BID);
  prevNZDJPYbid = SymbolInfoDouble(NZDJPYsym, SYMBOL_BID);
  prevGBPCHFbid = SymbolInfoDouble(GBPCHFsym, SYMBOL_BID);
  prevCHFJPYbid = SymbolInfoDouble(CHFJPYsym, SYMBOL_BID);
  prevEURCHFbid = SymbolInfoDouble(EURCHFsym, SYMBOL_BID);

  //PrintChartComments();
    
//  return(0);
}

//+------------------------------------------------------------------+
//|          Assign values to global variable namestrings.           |
//+------------------------------------------------------------------+

void SetGlobalVariableNames()
{
  LowestMarginLevel = MagicNumber+"_LowestMarginLevel";
  LargestFloatingLoss = MagicNumber+"_LargestFloatingLoss";
  MaxFloatingDrawdown = MagicNumber+"_MaxFloatingDrawdown";

  LastFlatBal = MagicNumber+"_LastFlatBal";
  LastFlatEq  = MagicNumber+"_LastFlatEq";

  GBPUSDadded = MagicNumber+"_GBPUSDadded";
  EURGBPadded = MagicNumber+"_EURGBPadded";
  GBPJPYadded = MagicNumber+"_GBPJPYadded";
  USDCHFadded = MagicNumber+"_USDCHFadded";
  NZDUSDadded = MagicNumber+"_NZDUSDadded";
  AUDJPYadded = MagicNumber+"_AUDJPYadded";
  EURJPYadded = MagicNumber+"_EURJPYadded";

  EURUSDadded = MagicNumber+"_EURUSDadded";
  USDJPYadded = MagicNumber+"_USDJPYadded";
  AUDUSDadded = MagicNumber+"_AUDUSDadded";
  NZDJPYadded = MagicNumber+"_NZDJPYadded";
  GBPCHFadded = MagicNumber+"_GBPCHFadded";
  CHFJPYadded = MagicNumber+"_CHFJPYadded";
  EURCHFadded = MagicNumber+"_EURCHFadded";

 
}

//+------------------------------------------------------------------+
//|            Assign initial values to global variables.            |
//+------------------------------------------------------------------+

void InitGlobalVars()
{
  if (!GlobalVariableCheck(LowestMarginLevel)) GlobalVariableSet(LowestMarginLevel, 100000000.0);
  if (!GlobalVariableCheck(LargestFloatingLoss)) GlobalVariableSet(LargestFloatingLoss, 0.0);
  if (!GlobalVariableCheck(MaxFloatingDrawdown)) GlobalVariableSet(MaxFloatingDrawdown, 0.0);

  if (!GlobalVariableCheck(LastFlatBal)) GlobalVariableSet(LastFlatBal, AccountInfoDouble(ACCOUNT_BALANCE));
  if (!GlobalVariableCheck(LastFlatEq)) GlobalVariableSet(LastFlatEq, AccountInfoDouble(ACCOUNT_EQUITY));

  if (!GlobalVariableCheck(GBPUSDadded)) GlobalVariableSet(GBPUSDadded, false);
  if (!GlobalVariableCheck(EURGBPadded)) GlobalVariableSet(EURGBPadded, false);
  if (!GlobalVariableCheck(GBPJPYadded)) GlobalVariableSet(GBPJPYadded, false);
  if (!GlobalVariableCheck(USDCHFadded)) GlobalVariableSet(USDCHFadded, false);
  if (!GlobalVariableCheck(NZDUSDadded)) GlobalVariableSet(NZDUSDadded, false);
  if (!GlobalVariableCheck(AUDJPYadded)) GlobalVariableSet(AUDJPYadded, false);
  if (!GlobalVariableCheck(EURJPYadded)) GlobalVariableSet(EURJPYadded, false);

  if (!GlobalVariableCheck(EURUSDadded)) GlobalVariableSet(EURUSDadded, false);
  if (!GlobalVariableCheck(USDJPYadded)) GlobalVariableSet(USDJPYadded, false);
  if (!GlobalVariableCheck(AUDUSDadded)) GlobalVariableSet(AUDUSDadded, false);
  if (!GlobalVariableCheck(NZDJPYadded)) GlobalVariableSet(NZDJPYadded, false);
  if (!GlobalVariableCheck(GBPCHFadded)) GlobalVariableSet(GBPCHFadded, false);
  if (!GlobalVariableCheck(CHFJPYadded)) GlobalVariableSet(CHFJPYadded, false);
  if (!GlobalVariableCheck(EURCHFadded)) GlobalVariableSet(EURCHFadded, false);

 
}

//+------------------------------------------------------------------+
//|   Get global variable values via their namestring and assign the |
//|   stored values to the variables used in the EA's logic.         |
//+------------------------------------------------------------------+

void RefreshGlobalVars()
{
  valLowestMarginLevel = GlobalVariableGet(LowestMarginLevel);
  valLargestFloatingLoss = GlobalVariableGet(LargestFloatingLoss);
  valMaxFloatingDrawdown = GlobalVariableGet(MaxFloatingDrawdown);

  valLastFlatBal = GlobalVariableGet(LastFlatBal);
  valLastFlatEq  = GlobalVariableGet(LastFlatEq);

  valGBPUSDadded = GlobalVariableGet(GBPUSDadded);
  valEURGBPadded = GlobalVariableGet(EURGBPadded);
  valGBPJPYadded = GlobalVariableGet(GBPJPYadded);
  valUSDCHFadded = GlobalVariableGet(USDCHFadded);
  valNZDUSDadded = GlobalVariableGet(NZDUSDadded);
  valAUDJPYadded = GlobalVariableGet(AUDJPYadded);
  valEURJPYadded = GlobalVariableGet(EURJPYadded);

  valEURUSDadded = GlobalVariableGet(EURUSDadded);
  valUSDJPYadded = GlobalVariableGet(USDJPYadded);
  valAUDUSDadded = GlobalVariableGet(AUDUSDadded);
  valNZDJPYadded = GlobalVariableGet(NZDJPYadded);
  valGBPCHFadded = GlobalVariableGet(GBPCHFadded);
  valCHFJPYadded = GlobalVariableGet(CHFJPYadded);
  valEURCHFadded = GlobalVariableGet(EURCHFadded);

  
}

//+------------------------------------------------------------------+
//|  Get important account parameters that affect how the lot size   |
//|  will be set.                                                    |
//+------------------------------------------------------------------+

void GetAccountInfo()
{
  // Get account leverage, account type.
  Leverage       = AccountInfoInteger(ACCOUNT_LEVERAGE);

  AccountTypeVal = SymbolInfoDouble(Symbol(),SYMBOL_TRADE_CONTRACT_SIZE);
  MaxLots        = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MAX);
  MinLots        = SymbolInfoDouble(Symbol(),SYMBOL_VOLUME_MIN);
  
}

//+------------------------------------------------------------------+
//|                 Set the traded symbol strings.                   |
//+------------------------------------------------------------------+

void SetSymbols()
{
  string AddMangle = "";
  if (StringLen(Symbol()) > 6) AddMangle = StringSubstr(Symbol(), 6);

  GBPUSDsym = "GBPUSD" + AddMangle;
  EURGBPsym = "EURGBP" + AddMangle;
  GBPJPYsym = "GBPJPY" + AddMangle;
  USDCHFsym = "USDCHF" + AddMangle;
  NZDUSDsym = "NZDUSD" + AddMangle;
  AUDJPYsym = "AUDJPY" + AddMangle;
  EURJPYsym = "EURJPY" + AddMangle;

  EURUSDsym = "EURUSD" + AddMangle;
  USDJPYsym = "USDJPY" + AddMangle;
  AUDUSDsym = "AUDUSD" + AddMangle;
  NZDJPYsym = "NZDJPY" + AddMangle;
  GBPCHFsym = "GBPCHF" + AddMangle;
  CHFJPYsym = "CHFJPY" + AddMangle;
  EURCHFsym = "EURCHF" + AddMangle;

  SymbolArray[GBPUSDidx] = GBPUSDsym;
  SymbolArray[EURGBPidx] = EURGBPsym;
  SymbolArray[GBPJPYidx] = GBPJPYsym;
  SymbolArray[USDCHFidx] = USDCHFsym;
  SymbolArray[NZDUSDidx] = NZDUSDsym;
  SymbolArray[AUDJPYidx] = AUDJPYsym;
  SymbolArray[EURJPYidx] = EURJPYsym;

  SymbolArray[EURUSDidx] = EURUSDsym;
  SymbolArray[USDJPYidx] = USDJPYsym;
  SymbolArray[AUDUSDidx] = AUDUSDsym;
  SymbolArray[NZDJPYidx] = NZDJPYsym;
  SymbolArray[GBPCHFidx] = GBPCHFsym;
  SymbolArray[CHFJPYidx] = CHFJPYsym;
  SymbolArray[EURCHFidx] = EURCHFsym;

  
}

//+------------------------------------------------------------------+
//|                    Reset the phantom trades.                     |
//+------------------------------------------------------------------+

void ResetPhantoms()
{
  GBPUSDask = 0.0;
  EURGBPask = 0.0;
  GBPJPYask = 0.0;
  USDCHFask = 0.0;
  NZDUSDask = 0.0;
  AUDJPYask = 0.0;
  EURJPYask = 0.0;

  EURUSDbid = 0.0;
  USDJPYbid = 0.0;
  AUDUSDbid = 0.0;
  NZDJPYbid = 0.0;
  GBPCHFbid = 0.0;
  CHFJPYbid = 0.0;
  EURCHFbid = 0.0;

  GlobalVariableSet(strGBPUSDask, GBPUSDask);
  GlobalVariableSet(strEURGBPask, EURGBPask);
  GlobalVariableSet(strGBPJPYask, GBPJPYask);
  GlobalVariableSet(strUSDCHFask, USDCHFask);
  GlobalVariableSet(strNZDUSDask, NZDUSDask);
  GlobalVariableSet(strAUDJPYask, AUDJPYask);
  GlobalVariableSet(strEURJPYask, EURJPYask);

  GlobalVariableSet(strEURUSDbid, EURUSDbid);
  GlobalVariableSet(strUSDJPYbid, USDJPYbid);
  GlobalVariableSet(strAUDUSDbid, AUDUSDbid);
  GlobalVariableSet(strNZDJPYbid, NZDJPYbid);
  GlobalVariableSet(strGBPCHFbid, GBPCHFbid);
  GlobalVariableSet(strCHFJPYbid, CHFJPYbid);
  GlobalVariableSet(strEURCHFbid, EURCHFbid);

  
}

//+------------------------------------------------------------------+
//|                       Open phantom trades.                       |
//+------------------------------------------------------------------+

void OpenPhantomTrades()
{
  if (GBPUSDask == 0.0 && EURGBPask == 0.0 &&
      GBPJPYask == 0.0 && USDCHFask == 0.0 &&
      NZDUSDask == 0.0 && AUDJPYask == 0.0 &&
      EURJPYask == 0.0 &&
      
      EURUSDbid == 0.0 && USDJPYbid == 0.0 &&
      AUDUSDbid == 0.0 && NZDJPYbid == 0.0 &&
      GBPCHFbid == 0.0 && CHFJPYbid == 0.0 &&
      EURCHFbid == 0.0)
  {
    GBPUSDask = SymbolInfoDouble(GBPUSDsym, SYMBOL_ASK);
    EURGBPask = SymbolInfoDouble(EURGBPsym, SYMBOL_ASK);
    GBPJPYask = SymbolInfoDouble(GBPJPYsym, SYMBOL_ASK);
    USDCHFask = SymbolInfoDouble(USDCHFsym, SYMBOL_ASK);
    NZDUSDask = SymbolInfoDouble(NZDUSDsym, SYMBOL_ASK);
    AUDJPYask = SymbolInfoDouble(AUDJPYsym, SYMBOL_ASK);
    EURJPYask = SymbolInfoDouble(EURJPYsym, SYMBOL_ASK);

    EURUSDbid = SymbolInfoDouble(EURUSDsym, SYMBOL_ASK);
    USDJPYbid = SymbolInfoDouble(USDJPYsym, SYMBOL_ASK);
    AUDUSDbid = SymbolInfoDouble(AUDUSDsym, SYMBOL_ASK);
    NZDJPYbid = SymbolInfoDouble(NZDJPYsym, SYMBOL_ASK);
    GBPCHFbid = SymbolInfoDouble(GBPCHFsym, SYMBOL_ASK);
    CHFJPYbid = SymbolInfoDouble(CHFJPYsym, SYMBOL_ASK);
    EURCHFbid = SymbolInfoDouble(EURCHFsym, SYMBOL_ASK);

    GlobalVariableSet(strGBPUSDask, GBPUSDask);
    GlobalVariableSet(strEURGBPask, EURGBPask);
    GlobalVariableSet(strGBPJPYask, GBPJPYask);
    GlobalVariableSet(strUSDCHFask, USDCHFask);
    GlobalVariableSet(strNZDUSDask, NZDUSDask);
    GlobalVariableSet(strAUDJPYask, AUDJPYask);
    GlobalVariableSet(strEURJPYask, EURJPYask);

    GlobalVariableSet(strEURUSDbid, EURUSDbid);
    GlobalVariableSet(strUSDJPYbid, USDJPYbid);
    GlobalVariableSet(strAUDUSDbid, AUDUSDbid);
    GlobalVariableSet(strNZDJPYbid, NZDJPYbid);
    GlobalVariableSet(strGBPCHFbid, GBPCHFbid);
    GlobalVariableSet(strCHFJPYbid, CHFJPYbid);
    GlobalVariableSet(strEURCHFbid, EURCHFbid);
  }

  
}

//+------------------------------------------------------------------+
//|             Set the account type and minimum equity.             |
//+------------------------------------------------------------------+

void SetAccountType()
{
  if (AccountTypeVal == MiniSize || StringLen(Symbol()) == 7)
  {
    AccountIsMini     = true;
    AccountTypeString = "MINI";
  }
  else if (AccountTypeVal == StdSize || StringLen(Symbol()) == 6)
  {
    AccountIsMini     = false;
    AccountTypeString = "STANDARD";
  }
  
  
}

//+------------------------------------------------------------------+
//|                 Set the lot size for any trades.                 |
//+------------------------------------------------------------------+

void SetLotSize()
{
  Investment = MaxMarginToUse / 100.0;

  // The symbol the EA is attached to should be good enough for the purposes of LOTSIZE
  UseLots = valLastFlatEq * Investment * (Leverage / SymbolInfoDouble(Symbol(),SYMBOL_TRADE_CONTRACT_SIZE));
  UseLots = StringToDouble(DoubleToString(UseLots,2));

  if (UseSmallestLot || UseLots < MinLots) UseLots = MinLots;
  if (UseLots > MaxLots) UseLots = MaxLots;

  
}

//+------------------------------------------------------------------+
//|  Do some accounting -- count the profit/loss, the open trades,   |
//|  and the number of open lots.                                    |
//+------------------------------------------------------------------+

void Count_PL_Trades_Lots()
{
  NumBuys            =    0;
  NumSells           =    0;
  TotalTrades        =    0;
  EAPL               =    0.0;
  BuyPL              =    0.0;
  SellPL             =    0.0;
  TotalLots          =    0.0;
  BuyLots            =    0.0;
  SellLots           =    0.0;

  GBPUSDbuys = 0; GBPUSDsells = 0;
  EURGBPbuys = 0; EURGBPsells = 0;
  GBPJPYbuys = 0; GBPJPYsells = 0;
  USDCHFbuys = 0; USDCHFsells = 0;
  NZDUSDbuys = 0; NZDUSDsells = 0;
  AUDJPYbuys = 0; AUDJPYsells = 0;
  EURJPYbuys = 0; EURJPYsells = 0;

  EURUSDbuys = 0; EURUSDsells = 0;
  USDJPYbuys = 0; USDJPYsells = 0;
  AUDUSDbuys = 0; AUDUSDsells = 0;
  NZDJPYbuys = 0; NZDJPYsells = 0;
  GBPCHFbuys = 0; GBPCHFsells = 0;
  CHFJPYbuys = 0; CHFJPYsells = 0;
  EURCHFbuys = 0; EURCHFsells = 0;

  BiggestWinnerPL = 0.0;
  BiggestWinnerLots = 0.0;
  BiggestWinnerTicket = 0;
  BiggestWinnerType = "";
  BiggestWinnerSymbol = "";

  BiggestLoserPL = 0.0;
  BiggestLoserLots = 0.0;
  BiggestLoserTicket = 0;
  BiggestLoserType = "";
  BiggestLoserSymbol = "";

  for (int i = 0; i < VOM.OrdersTotal(); i++)
  {
  //  uint ticket=OrderGetTicket(i);

  
//+------------------------------------------------------------------+
/// Select an open virtual order.
/// \param [in] i			Either index or ticket
/// \param [in] type		Either SELECT_BY_POS or SELECT_BY_TICKET		
/// \param [in] pool		Either MODE_TRADES (default) or MODE_HISTORY
/// \return					True if successful, false otherwise
//+------------------------------------------------------------------+
//bool CVirtualOrderManager::OrderSelect(long i,ENUM_VIRTUAL_SELECT_TYPE type,ENUM_VIRTUAL_SELECT_MODE pool=MODE_TRADES)
          
    VOM.OrderSelect(i,SELECT_BY_POS);
    //if (OrderMagicNumber() == MagicNumber)
    {
      PairOverallPL = VOM.OrderProfit() + VOM.OrderCommission();//TODO  VOM.OrderSwap();
      EAPL  += PairOverallPL;
      TotalLots += VOM.OrderLots();

      if (VOM.OrderType() == VIRTUAL_ORDER_TYPE_BUY)
      {
        BuyPL += PairOverallPL;

        if (PairOverallPL > BiggestWinnerPL)
        {
          BiggestWinnerPL     = PairOverallPL;
          BiggestWinnerLots   = VOM.OrderLots();
          BiggestWinnerTicket = VOM.OrderTicket();
          BiggestWinnerType   = "BUY";
          BiggestWinnerSymbol = VOM.OrderSymbol();
        }

        if (PairOverallPL < BiggestLoserPL)
        {
          BiggestLoserPL     = PairOverallPL;
          BiggestLoserLots   = VOM.OrderLots();
          BiggestLoserTicket = VOM.OrderTicket();
          BiggestLoserType   = "BUY";
          BiggestLoserSymbol = VOM.OrderSymbol();
        }

        BuyLots += VOM.OrderLots();

        NumBuys++;

        if (VOM.OrderSymbol() == GBPUSDsym) { GBPUSDbuys++; GBPUSDPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == EURGBPsym) { EURGBPbuys++; EURGBPPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == GBPJPYsym) { GBPJPYbuys++; GBPJPYPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == USDCHFsym) { USDCHFbuys++; USDCHFPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == NZDUSDsym) { NZDUSDbuys++; NZDUSDPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == AUDJPYsym) { AUDJPYbuys++; AUDJPYPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == EURJPYsym) { EURJPYbuys++; EURJPYPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == EURUSDsym) { EURUSDbuys++; EURUSDPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == USDJPYsym) { USDJPYbuys++; USDJPYPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == AUDUSDsym) { AUDUSDbuys++; AUDUSDPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == NZDJPYsym) { NZDJPYbuys++; NZDJPYPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == GBPCHFsym) { GBPCHFbuys++; GBPCHFPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == CHFJPYsym) { CHFJPYbuys++; CHFJPYPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == EURCHFsym) { EURCHFbuys++; EURCHFPL = PairOverallPL; }
      }

      if (VOM.OrderType() == VIRTUAL_ORDER_TYPE_SELL)
      {
        SellPL += PairOverallPL;

        if (PairOverallPL> BiggestWinnerPL)
        {
          BiggestWinnerPL     = PairOverallPL;
          BiggestWinnerLots   = VOM.OrderLots();
          BiggestWinnerTicket = VOM.OrderTicket();
          BiggestWinnerType   = "SELL";
          BiggestWinnerSymbol = VOM.OrderSymbol();
        }

        if (PairOverallPL< BiggestLoserPL)
        {
          BiggestLoserPL     = PairOverallPL;
          BiggestLoserLots   = VOM.OrderLots();
          BiggestLoserTicket = VOM.OrderTicket();
          BiggestLoserType   = "SELL";
          BiggestLoserSymbol = VOM.OrderSymbol();
        }

        SellLots += VOM.OrderLots();

        NumSells++;

        if (VOM.OrderSymbol() == GBPUSDsym) { GBPUSDsells++; GBPUSDPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == EURGBPsym) { EURGBPsells++; EURGBPPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == GBPJPYsym) { GBPJPYsells++; GBPJPYPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == USDCHFsym) { USDCHFsells++; USDCHFPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == NZDUSDsym) { NZDUSDsells++; NZDUSDPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == AUDJPYsym) { AUDJPYsells++; AUDJPYPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == EURJPYsym) { EURJPYsells++; EURJPYPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == EURUSDsym) { EURUSDsells++; EURUSDPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == USDJPYsym) { USDJPYsells++; USDJPYPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == AUDUSDsym) { AUDUSDsells++; AUDUSDPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == NZDJPYsym) { NZDJPYsells++; NZDJPYPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == GBPCHFsym) { GBPCHFsells++; GBPCHFPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == CHFJPYsym) { CHFJPYsells++; CHFJPYPL = PairOverallPL; }
        else
        if (VOM.OrderSymbol() == EURCHFsym) { EURCHFsells++; EURCHFPL = PairOverallPL; }
      }
    }
  }
  TotalTrades = NumBuys+NumSells;
 
}

//+------------------------------------------------------------------+
//|         Set the dollar profit and trim target values.            |
//+------------------------------------------------------------------+

void SetExitTargets()
{
  DollarProfitTarget = StringToDouble(DoubleToString(valLastFlatEq*ProfitPct/100.0,2));

  if (AccountIsMini)
  {
    if (DollarProfitTarget > MaxMiniProfit) DollarProfitTarget = MaxMiniProfit;
  }
  else
  {
    if (DollarProfitTarget > MaxStdProfit) DollarProfitTarget = MaxStdProfit;
  }

 
}

//+------------------------------------------------------------------+
//|                 Close all of the open trades.                    |
//+------------------------------------------------------------------+

void CloseAllTradesIfNeeded()
{
  if (BidsHaveChanged && CloseAll)
  {
Print("closeAll ",VOM.OrdersTotal()," trades");
    for(int i = 0; i < VOM.OrdersTotal(); i++)
    {
      VOM.OrderSelect(i,SELECT_BY_POS,MODE_TRADES);

      //if (VOM.OrderMagicNumber() == MagicNumber)
      {
        if (VOM.OrderType() == VIRTUAL_ORDER_TYPE_BUY)
        {
          Comment("In full closure mode.  Closing a ", VOM.OrderSymbol(), " buy trade...");
          Print("In full closure mode.  Closing a ", VOM.OrderSymbol(), " buy trade...");
          //VOM.OrderClose(VOM.OrderTicket(),VOM.OrderLots(),SymbolInfoDouble(VOM.OrderSymbol(), SYMBOL_BID),Slippage,White);
          VOM.OrderClose(VOM.OrderTicket(),Slippage,White);
          Sleep(1000);
        }    
        else
        if (VOM.OrderType() == VIRTUAL_ORDER_TYPE_SELL)
        {
          Comment("In full closure mode.  Closing a ", VOM.OrderSymbol(), " sell trade...");
          Print("In full closure mode.  Closing a ", VOM.OrderSymbol(), " sell trade...");
          VOM.OrderClose(VOM.OrderTicket(),Slippage,White);

          Sleep(1000);
        }
      }
    }
  }
  
  
}

//+------------------------------------------------------------------+
//|                 Clear all symbol-added marks.                    |
//+------------------------------------------------------------------+

void ClearSymbolMarks()
{
  valGBPUSDadded = false;
  GlobalVariableSet(GBPUSDadded, valGBPUSDadded);

  valEURGBPadded = false;
  GlobalVariableSet(EURGBPadded, valEURGBPadded);

  valGBPJPYadded = false;
  GlobalVariableSet(GBPJPYadded, valGBPJPYadded);

  valUSDCHFadded = false;
  GlobalVariableSet(USDCHFadded, valUSDCHFadded);

  valNZDUSDadded = false;
  GlobalVariableSet(NZDUSDadded, valNZDUSDadded);

  valAUDJPYadded = false;
  GlobalVariableSet(AUDJPYadded, valAUDJPYadded);

  valEURJPYadded = false;
  GlobalVariableSet(EURJPYadded, valEURJPYadded);

  valEURUSDadded = false;
  GlobalVariableSet(EURUSDadded, valEURUSDadded);

  valUSDJPYadded = false;
  GlobalVariableSet(USDJPYadded, valUSDJPYadded);

  valAUDUSDadded = false;
  GlobalVariableSet(AUDUSDadded, valAUDUSDadded);

  valNZDJPYadded = false;
  GlobalVariableSet(NZDJPYadded, valNZDJPYadded);

  valGBPCHFadded = false;
  GlobalVariableSet(GBPCHFadded, valGBPCHFadded);

  valCHFJPYadded = false;
  GlobalVariableSet(CHFJPYadded, valCHFJPYadded);

  valEURCHFadded = false;
  GlobalVariableSet(EURCHFadded, valEURCHFadded);

  
}

//+------------------------------------------------------------------+
//|                 Mark the given currency pair as added.           |
//+------------------------------------------------------------------+

void MarkSymbolAdded(string theSymbol)
{
  if (theSymbol == GBPUSDsym)
  {
    valGBPUSDadded = true;
    GlobalVariableSet(GBPUSDadded, valGBPUSDadded);
  }
  else
  if (theSymbol == EURGBPsym)
  {
    valEURGBPadded = true;
    GlobalVariableSet(EURGBPadded, valEURGBPadded);
  }
  else
  if (theSymbol == GBPJPYsym)
  {
    valGBPJPYadded = true;
    GlobalVariableSet(GBPJPYadded, valGBPJPYadded);
  }
  else
  if (theSymbol == USDCHFsym)
  {
    valUSDCHFadded = true;
    GlobalVariableSet(USDCHFadded, valUSDCHFadded);
  }
  else
  if (theSymbol == NZDUSDsym)
  {
    valNZDUSDadded = true;
    GlobalVariableSet(NZDUSDadded, valNZDUSDadded);
  }
  else
  if (theSymbol == AUDJPYsym)
  {
    valAUDJPYadded = true;
    GlobalVariableSet(AUDJPYadded, valAUDJPYadded);
  }
  else
  if (theSymbol == EURJPYsym)
  {
    valEURJPYadded = true;
    GlobalVariableSet(EURJPYadded, valEURJPYadded);
  }
  else
  if (theSymbol == EURUSDsym)
  {
    valEURUSDadded = true;
    GlobalVariableSet(EURUSDadded, valEURUSDadded);
  }
  else
  if (theSymbol == USDJPYsym)
  {
    valUSDJPYadded = true;
    GlobalVariableSet(USDJPYadded, valUSDJPYadded);
  }
  else
  if (theSymbol == AUDUSDsym)
  {
    valAUDUSDadded = true;
    GlobalVariableSet(AUDUSDadded, valAUDUSDadded);
  }
  else
  if (theSymbol == NZDJPYsym)
  {
    valNZDJPYadded = true;
    GlobalVariableSet(NZDJPYadded, valNZDJPYadded);
  }
  else
  if (theSymbol == GBPCHFsym)
  {
    valGBPCHFadded = true;
    GlobalVariableSet(GBPCHFadded, valGBPCHFadded);
  }
  else
  if (theSymbol == CHFJPYsym)
  {
    valCHFJPYadded = true;
    GlobalVariableSet(CHFJPYadded, valCHFJPYadded);
  }
  else
  if (theSymbol == EURCHFsym)
  {
    valEURCHFadded = true;
    GlobalVariableSet(EURCHFadded, valEURCHFadded);
  }

  
}

//+------------------------------------------------------------------+
//|          Check if the given currency is marked as added.         |
//+------------------------------------------------------------------+

bool SymbolMarked(string theSymbol)
{
  if (theSymbol == GBPUSDsym && valGBPUSDadded)
  {
    return(true);
  }
  else
  if (theSymbol == EURGBPsym && valEURGBPadded)
  {
    return(true);
  }
  else
  if (theSymbol == GBPJPYsym && valGBPJPYadded)
  {
    return(true);
  }
  else
  if (theSymbol == USDCHFsym && valUSDCHFadded)
  {
    return(true);
  }
  else
  if (theSymbol == NZDUSDsym && valNZDUSDadded)
  {
    return(true);
  }
  else
  if (theSymbol == AUDJPYsym && valAUDJPYadded)
  {
    return(true);
  }
  else
  if (theSymbol == EURJPYsym && valEURJPYadded)
  {
    return(true);
  }
  else
  if (theSymbol == EURUSDsym && valEURUSDadded)
  {
    return(true);
  }
  else
  if (theSymbol == USDJPYsym && valUSDJPYadded)
  {
    return(true);
  }
  else
  if (theSymbol == AUDUSDsym && valAUDUSDadded)
  {
    return(true);
  }
  else
  if (theSymbol == NZDJPYsym && valNZDJPYadded)
  {
    return(true);
  }
  else
  if (theSymbol == GBPCHFsym && valGBPCHFadded)
  {
    return(true);
  }
  else
  if (theSymbol == CHFJPYsym && valCHFJPYadded)
  {
    return(true);
  }
  else
  if (theSymbol == EURCHFsym && valEURCHFadded)
  {
    return(true);
  }

  return(false);
}

//+------------------------------------------------------------------+
//|     Correct problem of brokers using 3 or 5 digit pricing        |
//+------------------------------------------------------------------+

double SetPoint(string theSymbol)
{
  double mPoint;
   
  int mDigits = SymbolInfoInteger(theSymbol, SYMBOL_DIGITS);

  if (mDigits < 4)
    mPoint = 0.01;
  else
    mPoint = 0.0001;

  return(mPoint);
}

//+------------------------------------------------------------------+
//|     Correct problem of brokers using 3 or 5 digit pricing        |
//+------------------------------------------------------------------+

double SetTickValue(string theSymbol, double thePoint)
{
  double mTickValue;
   
  if (thePoint/10.0 == SymbolInfoDouble(theSymbol, SYMBOL_POINT))
  {
    mTickValue = SymbolInfoDouble(theSymbol, SYMBOL_TRADE_TICK_VALUE)*10.0;
  }
  else // if (thePoint == MarketInfo(theSymbol, MODE_POINT))
  {
    mTickValue = SymbolInfoDouble(theSymbol, SYMBOL_TRADE_TICK_VALUE);
  }

  return(mTickValue);
}

//+------------------------------------------------------------------+
//|                Set the value of Point for each pair.             |
//+------------------------------------------------------------------+

void SetPointsAndTickvalues()
{
  GBPUSDpoint = SetPoint(GBPUSDsym);
  EURGBPpoint = SetPoint(EURGBPsym);
  GBPJPYpoint = SetPoint(GBPJPYsym);
  USDCHFpoint = SetPoint(USDCHFsym);
  NZDUSDpoint = SetPoint(NZDUSDsym);
  AUDJPYpoint = SetPoint(AUDJPYsym);
  EURJPYpoint = SetPoint(EURJPYsym);

  EURUSDpoint = SetPoint(EURUSDsym);
  USDJPYpoint = SetPoint(USDJPYsym);
  AUDUSDpoint = SetPoint(AUDUSDsym);
  NZDJPYpoint = SetPoint(NZDJPYsym);
  GBPCHFpoint = SetPoint(GBPCHFsym);
  CHFJPYpoint = SetPoint(CHFJPYsym);
  EURCHFpoint = SetPoint(EURCHFsym);

  GBPUSDtickval = SetTickValue(GBPUSDsym, GBPUSDpoint);
  TickvalArray[GBPUSDidx] = GBPUSDtickval;

  EURGBPtickval = SetTickValue(EURGBPsym, EURGBPpoint);
  TickvalArray[EURGBPidx] = EURGBPtickval;

  GBPJPYtickval = SetTickValue(GBPJPYsym, GBPJPYpoint);
  TickvalArray[GBPJPYidx] = GBPJPYtickval;

  USDCHFtickval = SetTickValue(USDCHFsym, USDCHFpoint);
  TickvalArray[USDCHFidx] = USDCHFtickval;

  NZDUSDtickval = SetTickValue(NZDUSDsym, NZDUSDpoint);
  TickvalArray[NZDUSDidx] = NZDUSDtickval;

  AUDJPYtickval = SetTickValue(AUDJPYsym, AUDJPYpoint);
  TickvalArray[AUDJPYidx] = AUDJPYtickval;

  EURJPYtickval = SetTickValue(EURJPYsym, EURJPYpoint);
  TickvalArray[EURJPYidx] = EURJPYtickval;

  EURUSDtickval = SetTickValue(EURUSDsym, EURUSDpoint);
  TickvalArray[EURUSDidx] = EURUSDtickval;

  USDJPYtickval = SetTickValue(USDJPYsym, USDJPYpoint);
  TickvalArray[USDJPYidx] = USDJPYtickval;

  AUDUSDtickval = SetTickValue(AUDUSDsym, AUDUSDpoint);
  TickvalArray[AUDUSDidx] = AUDUSDtickval;

  NZDJPYtickval = SetTickValue(NZDJPYsym, NZDJPYpoint);
  TickvalArray[NZDJPYidx] = NZDJPYtickval;

  GBPCHFtickval = SetTickValue(GBPCHFsym, GBPCHFpoint);
  TickvalArray[GBPCHFidx] = GBPCHFtickval;

  CHFJPYtickval = SetTickValue(CHFJPYsym, CHFJPYpoint);
  TickvalArray[CHFJPYidx] = CHFJPYtickval;

  EURCHFtickval = SetTickValue(EURCHFsym, EURCHFpoint);
  TickvalArray[EURCHFidx] = EURCHFtickval;

  
}

//+------------------------------------------------------------------+
//|                 Calculate PL for phantom trades.                 |
//+------------------------------------------------------------------+

void CalcPhantomPL()
{
  SetPointsAndTickvalues();
  //SymbolInfoDouble(GBPUSDsym, SYMBOL_BID) ||
  if (GBPUSDpoint != 0.0)
  {
    GBPUSD_PL = (SymbolInfoDouble(GBPUSDsym, SYMBOL_BID) - GBPUSDask) / GBPUSDpoint;
    GBPUSD_PL *= TickvalArray[GBPUSDidx]*UseLots;
    PL_Array[GBPUSDidx] = GBPUSD_PL;
  }

  if (EURGBPpoint != 0.0)
  {
    EURGBP_PL = (SymbolInfoDouble(EURGBPsym, SYMBOL_BID) - EURGBPask) / EURGBPpoint;
    EURGBP_PL *= TickvalArray[EURGBPidx]*UseLots;
    PL_Array[EURGBPidx] = EURGBP_PL;
  }
  
  if (GBPJPYpoint != 0.0)
  {
    GBPJPY_PL = (SymbolInfoDouble(GBPJPYsym, SYMBOL_BID) - GBPJPYask) / GBPJPYpoint;
    GBPJPY_PL *= TickvalArray[GBPJPYidx]*UseLots;
    PL_Array[GBPJPYidx] = GBPJPY_PL;
  }

  if (USDCHFpoint != 0.0)
  {
    USDCHF_PL = (SymbolInfoDouble(USDCHFsym, SYMBOL_BID) - USDCHFask) / USDCHFpoint;
    USDCHF_PL *= TickvalArray[USDCHFidx]*UseLots;
    PL_Array[USDCHFidx] = USDCHF_PL;
  }

  if (NZDUSDpoint != 0.0)
  {
    NZDUSD_PL = (SymbolInfoDouble(NZDUSDsym, SYMBOL_BID) - NZDUSDask) / NZDUSDpoint;
    NZDUSD_PL *= TickvalArray[NZDUSDidx]*UseLots;
    PL_Array[NZDUSDidx] = NZDUSD_PL;
  }

  if (AUDJPYpoint != 0.0)
  {
    AUDJPY_PL = (SymbolInfoDouble(AUDJPYsym, SYMBOL_BID) - AUDJPYask) / AUDJPYpoint;
    AUDJPY_PL *= TickvalArray[AUDJPYidx]*UseLots;
    PL_Array[AUDJPYidx] = AUDJPY_PL;
  }

  if (EURJPYpoint != 0.0)
  {
    EURJPY_PL = (SymbolInfoDouble(EURJPYsym, SYMBOL_BID) - EURJPYask) / EURJPYpoint;
    EURJPY_PL *= TickvalArray[EURJPYidx]*UseLots;
    PL_Array[EURJPYidx] = EURJPY_PL;
  }

  phantomBuyPL = GBPUSD_PL + EURGBP_PL + GBPJPY_PL + USDCHF_PL + NZDUSD_PL + AUDJPY_PL + EURJPY_PL;

  if (EURUSDpoint != 0.0)
  {
    EURUSD_PL = (EURUSDbid - SymbolInfoDouble(EURUSDsym, SYMBOL_ASK)) / EURUSDpoint;
    EURUSD_PL *= TickvalArray[EURUSDidx]*UseLots;
    PL_Array[EURUSDidx] = EURUSD_PL;
  }

  if (USDJPYpoint != 0.0)
  {
    USDJPY_PL = (USDJPYbid - SymbolInfoDouble(USDJPYsym, SYMBOL_ASK)) / USDJPYpoint;
    USDJPY_PL *= TickvalArray[USDJPYidx]*UseLots;
    PL_Array[USDJPYidx] = USDJPY_PL;
  }

  if (AUDUSDpoint != 0.0)
  {
    AUDUSD_PL = (AUDUSDbid - SymbolInfoDouble(AUDUSDsym, SYMBOL_ASK)) / AUDUSDpoint;
    AUDUSD_PL *= TickvalArray[AUDUSDidx]*UseLots;
    PL_Array[AUDUSDidx] = AUDUSD_PL;
  }

  if (NZDJPYpoint != 0.0)
  {
    NZDJPY_PL = (NZDJPYbid - SymbolInfoDouble(NZDJPYsym, SYMBOL_ASK)) / NZDJPYpoint;
    NZDJPY_PL *= TickvalArray[NZDJPYidx]*UseLots;
    PL_Array[NZDJPYidx] = NZDJPY_PL;
  }

  if (GBPCHFpoint != 0.0)
  {
    GBPCHF_PL = (GBPCHFbid - SymbolInfoDouble(GBPCHFsym, SYMBOL_ASK)) / GBPCHFpoint;
    GBPCHF_PL *= TickvalArray[GBPCHFidx]*UseLots;
    PL_Array[GBPCHFidx] = GBPCHF_PL;
  }

  if (CHFJPYpoint != 0.0)
  {
    CHFJPY_PL = (CHFJPYbid - SymbolInfoDouble(CHFJPYsym, SYMBOL_ASK)) / CHFJPYpoint;
    CHFJPY_PL *= TickvalArray[CHFJPYidx]*UseLots;
    PL_Array[CHFJPYidx] = CHFJPY_PL;
  }

  if (EURCHFpoint != 0.0)
  {
    EURCHF_PL = (EURCHFbid - SymbolInfoDouble(EURCHFsym, SYMBOL_ASK)) / EURCHFpoint;
    EURCHF_PL *= TickvalArray[EURCHFidx]*UseLots;
    PL_Array[EURCHFidx] = EURCHF_PL;
  }

  phantomSellPL = EURUSD_PL + USDJPY_PL + AUDUSD_PL + NZDJPY_PL + GBPCHF_PL + CHFJPY_PL + EURCHF_PL;
  phantomEAPL = phantomBuyPL + phantomSellPL;

  // Determine biggest phantom winner.

  BiggestPhantomWinnerPL = 0.0;
  BiggestPhantomWinnerType = "";
  BiggestPhantomWinnerSymbol = "";

  if (GBPUSD_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = GBPUSD_PL;
    BiggestPhantomWinnerType   = "BUY";
    BiggestPhantomWinnerSymbol = GBPUSDsym;
  }

  if (EURGBP_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = EURGBP_PL;
    BiggestPhantomWinnerType   = "BUY";
    BiggestPhantomWinnerSymbol = EURGBPsym;
  }
  if (GBPJPY_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = GBPJPY_PL;
    BiggestPhantomWinnerType   = "BUY";
    BiggestPhantomWinnerSymbol = GBPJPYsym;
  }
  if (USDCHF_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = USDCHF_PL;
    BiggestPhantomWinnerType   = "BUY";
    BiggestPhantomWinnerSymbol = USDCHFsym;
  }
  if (NZDUSD_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = NZDUSD_PL;
    BiggestPhantomWinnerType   = "BUY";
    BiggestPhantomWinnerSymbol = NZDUSDsym;
  }
  if (AUDJPY_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = AUDJPY_PL;
    BiggestPhantomWinnerType   = "BUY";
    BiggestPhantomWinnerSymbol = AUDJPYsym;
  }
  if (EURJPY_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = EURJPY_PL;
    BiggestPhantomWinnerType   = "BUY";
    BiggestPhantomWinnerSymbol = EURJPYsym;
  }


  if (EURUSD_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = EURUSD_PL;
    BiggestPhantomWinnerType   = "SELL";
    BiggestPhantomWinnerSymbol = EURUSDsym;
  }
  if (USDJPY_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = USDJPY_PL;
    BiggestPhantomWinnerType   = "SELL";
    BiggestPhantomWinnerSymbol = USDJPYsym;
  }
  if (AUDUSD_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = AUDUSD_PL;
    BiggestPhantomWinnerType   = "SELL";
    BiggestPhantomWinnerSymbol = AUDUSDsym;
  }
  if (NZDJPY_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = NZDJPY_PL;
    BiggestPhantomWinnerType   = "SELL";
    BiggestPhantomWinnerSymbol = NZDJPYsym;
  }
  if (GBPCHF_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = GBPCHF_PL;
    BiggestPhantomWinnerType   = "SELL";
    BiggestPhantomWinnerSymbol = GBPCHFsym;
  }
  if (CHFJPY_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = CHFJPY_PL;
    BiggestPhantomWinnerType   = "SELL";
    BiggestPhantomWinnerSymbol = CHFJPYsym;
  }
  if (EURCHF_PL > BiggestPhantomWinnerPL)
  {
    BiggestPhantomWinnerPL     = EURCHF_PL;
    BiggestPhantomWinnerType   = "SELL";
    BiggestPhantomWinnerSymbol = EURCHFsym;
  }


}

//+------------------------------------------------------------------+
//|               Check if all symbol trades in profit.              |
//+------------------------------------------------------------------+

bool AllSymbolTradesInProfit(string theSymbol)
{
  for (int j = 0; j < VOM.OrdersTotal(); j++)
  {
    VOM.OrderSelect(j,SELECT_BY_POS,MODE_TRADES);

    if (/*VOM.OrderMagicNumber() == MagicNumber &&*/
        VOM.OrderSymbol() == theSymbol        &&
        VOM.OrderProfit() <= 0.0)
    {
      return(false);
    }
  }

  return(true);
}

int TimeMinuteMQL4(datetime date)
{
   MqlDateTime tm;
   TimeToStruct(date,tm);
   return(tm.min);
}

int TimeHourMQL4(datetime date)
{
   MqlDateTime tm;
   TimeToStruct(date,tm);
   return(tm.hour);
}

//+------------------------------------------------------------------+
//|                     Add to winning trades.                       |
//+------------------------------------------------------------------+

void AddIfNeeded()
{
  if (TimeMinuteMQL4(TimeCurrent()) != 0) ClearSymbolMarks();

//Print("1"+BidsHaveChanged);
  if (BidsHaveChanged &&
      TimeMinuteMQL4(TimeCurrent()) == 0 &&
     !CloseAll)
  {
//Print("2"+BidsHaveChanged);
    for (int i = GBPUSDidx; i <= EURCHFidx; i++)
    {
      if (PL_Array[i] > 0.0 &&
           (SymbolArray[i] == EURCHFsym || SymbolArray[i] == EURJPYsym || SymbolArray[i] == CHFJPYsym ||
            SymbolArray[i] == GBPCHFsym || SymbolArray[i] == GBPUSDsym || SymbolArray[i] == USDCHFsym) &&
         !SymbolMarked(SymbolArray[i]))
      {
        if (AllSymbolTradesInProfit(SymbolArray[i]) &&
            !SymbolMarked(SymbolArray[i]))
        {
          if (i < 7)
          {
            Comment("Adding a " + SymbolArray[i] + " buy trade...");
            Print("Adding a " + SymbolArray[i] + " long.");
            //OrderSend(string symbol,ENUM_VIRTUAL_ORDER_TYPE cmd,double volume,double price,int slippage,double stoploss,double takeprofit,string comment="",datetime expiration=0,color arrow_color=CLR_NONE);
            OrderSendResult = VOM.OrderSend(SymbolArray[i],VIRTUAL_ORDER_TYPE_BUY,UseLots,SymbolInfoDouble(SymbolArray[i], SYMBOL_ASK),
                                      Slippage,0,0,"Adding to a long phantom winner");//,MagicNumber,Blue);
            if (OrderSendResult > 0) MarkSymbolAdded(SymbolArray[i]);
            Sleep(1000);
          }
          else
          // if (i >= 7)
          {
            Comment("Adding a " + SymbolArray[i] + " sell trade...");
            Print("Adding a " + SymbolArray[i] + " short.");
            OrderSendResult = VOM.OrderSend(SymbolArray[i],VIRTUAL_ORDER_TYPE_SELL,UseLots,SymbolInfoDouble(SymbolArray[i], SYMBOL_BID),
                                        Slippage,0,0,"Adding to a short phantom winner");//,MagicNumber,Red);
            if (OrderSendResult > 0) MarkSymbolAdded(SymbolArray[i]);
            Sleep(1000);
          }
        }      
      } 
    } 
  }

  
}

//+------------------------------------------------------------------+
//|   Keep track of lowest margin level and largest floating loss.   |
//+------------------------------------------------------------------+

void ExamineMarginAndFloat()
{
  if (AccountInfoDouble(ACCOUNT_MARGIN) > 0.0)
  {
    PercentMarginLevel = StringToDouble(DoubleToString(100 * AccountInfoDouble(ACCOUNT_EQUITY) / AccountInfoDouble(ACCOUNT_MARGIN), 2));

    if (PercentMarginLevel < valLowestMarginLevel)
    {
      valLowestMarginLevel = PercentMarginLevel;
      GlobalVariableSet(LowestMarginLevel, valLowestMarginLevel);
    }
  }

  if (EAPL < valLargestFloatingLoss)
  {
    valLargestFloatingLoss = StringToDouble(DoubleToString(EAPL, 2));
    GlobalVariableSet(LargestFloatingLoss, valLargestFloatingLoss);
  }

  if ((valLargestFloatingLoss / valLastFlatEq) * 100.0 < valMaxFloatingDrawdown)
  {
    valMaxFloatingDrawdown = StringToDouble(DoubleToString((valLargestFloatingLoss / valLastFlatEq) * 100.0, 2));
    GlobalVariableSet(MaxFloatingDrawdown, valMaxFloatingDrawdown);
  }

  
}

//+------------------------------------------------------------------+
//|                      Print Info to Chart                         |
//+------------------------------------------------------------------+

void PrintChartComments()
{
   Comment(getChartComments());
}

void PrintComments()
{
   Print(getChartComments());
}
string getChartComments()
{
  string CommentString = 
        "STRATEGY: Every hour, add a trade to every winning EURCHF, EURJPY, CHFJPY, GBPCHF, GBPUSD, USDCHF phantom," +
        "\nbut only if all previous trades are winners. Close all when current equity exceeds ProfitPct above last flat equity." +
        "\n\nREMINDER: Be FLAT (all trades closed) before depositing/withdrawing funds." +
        "\n\nAccount Type: " + AccountTypeString + " Account,   Leverage: " + DoubleToString(Leverage,0) + ":1" +
        ",   Margin %: " + DoubleToString(PercentMarginLevel,2) + "%,   Lowest Margin %: " + DoubleToString(valLowestMarginLevel,2) + "%" +
        "\nLargest Floating Loss: $" + DoubleToString(valLargestFloatingLoss,2) + ",  Max Floating Drawdown %: " + DoubleToString(valMaxFloatingDrawdown,2) + "%" +
        "\nBalance: $" + DoubleToString(AccountInfoDouble(ACCOUNT_BALANCE),2) + ",   Equity: $" + DoubleToString(AccountInfoDouble(ACCOUNT_EQUITY),2) +
        "\nLast Flat Balance: $" + DoubleToString(valLastFlatBal,2) + ",   Last Flat Equity: $" + DoubleToString(valLastFlatEq,2) +
        "\nDollar Profit Target: $" + DoubleToString(DollarProfitTarget,2) + ",   Equity Profit Target: $" + DoubleToString(valLastFlatEq+DollarProfitTarget,2) +
        "\nOpen Buys: " + DoubleToString(NumBuys,0) + ",   Open Sells: " + DoubleToString(NumSells,0) + ",   Total Open Trades: " + DoubleToString(TotalTrades,0) +
        "\nGBPUSD Phantom PL: $" + DoubleToString(GBPUSD_PL,2) +
        "\nEURGBP Phantom PL: $" + DoubleToString(EURGBP_PL,2) +
        "\nGBPJPY Phantom PL: $" + DoubleToString(GBPJPY_PL,2) +
        "\nUSDCHF Phantom PL: $" + DoubleToString(USDCHF_PL,2) +
        "\nNZDUSD Phantom PL: $" + DoubleToString(NZDUSD_PL,2) +
        "\nAUDJPY Phantom PL: $" + DoubleToString(AUDJPY_PL,2) +
        "\nEURJPY Phantom PL: $" + DoubleToString(EURJPY_PL,2) +
        "\nEURUSD Phantom PL: $" + DoubleToString(EURUSD_PL,2) +
        "\nUSDJPY Phantom PL: $" + DoubleToString(USDJPY_PL,2) +
        "\nAUDUSD Phantom PL: $" + DoubleToString(AUDUSD_PL,2) +
        "\nNZDJPY Phantom PL: $" + DoubleToString(NZDJPY_PL,2) +
        "\nGBPCHF Phantom PL: $" + DoubleToString(GBPCHF_PL,2) +
        "\nCHFJPY Phantom PL: $" + DoubleToString(CHFJPY_PL,2) +
        "\nEURCHF Phantom PL: $" + DoubleToString(EURCHF_PL,2) +
        "\nPhantom Buy PL: $" + DoubleToString(phantomBuyPL,2) + ",   Phantom Sell PL: $" + DoubleToString(phantomSellPL,2) + "   Overall Phantom PL: $" + DoubleToString(phantomEAPL,2) +
        "\nEA PL: $" + DoubleToString(EAPL,2) + ",   Buy PL: $" + DoubleToString(BuyPL,2) + ",   Sell PL: $" + DoubleToString(SellPL,2) +
        "\nBiggest Winner Symbol: " + BiggestWinnerSymbol + ",   Biggest Winner Type: " + BiggestWinnerType + ",  Biggest Winner Ticket: " + DoubleToString(BiggestWinnerTicket,0) + ",   Biggest Winner PL: $" + DoubleToString(BiggestWinnerPL,2) +
        "\nBiggest Loser Symbol: " + BiggestLoserSymbol + ",   Biggest Loser Type: " + BiggestLoserType + ",  Biggest Loser Ticket: " + DoubleToString(BiggestLoserTicket,0) + ",   Biggest Loser PL: $" + DoubleToString(BiggestLoserPL,2);

   return CommentString;        
  

  
}


